# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/clock/spacemit,k1-pll.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: SpacemiT K1/K3 PLL

maintainers:
  - Haylen Chu <heylenay@4d2.org>

properties:
  compatible:
    enum:
      - spacemit,k1-pll
      - spacemit,k3-pll

  reg:
    maxItems: 1

  clocks:
    description: External 24MHz oscillator

  spacemit,mpmu:
    $ref: /schemas/types.yaml#/definitions/phandle
    description:
      Phandle to the "Main PMU (MPMU)" syscon. It is used to check PLL
      lock status.

  "#clock-cells":
    const: 1
    description:
      For K1 SoC, check <dt-bindings/clock/spacemit,k1-syscon.h> for valid indices.
      For K3 SoC, check <dt-bindings/clock/spacemit,k3-clocks.h> for valid indices.

required:
  - compatible
  - reg
  - clocks
  - spacemit,mpmu
  - "#clock-cells"

additionalProperties: false

examples:
  - |
    clock-controller@d4090000 {
        compatible = "spacemit,k1-pll";
        reg = <0xd4090000 0x1000>;
        clocks = <&vctcxo_24m>;
        spacemit,mpmu = <&sysctl_mpmu>;
        #clock-cells = <1>;
    };
